# Copyright (C) 2020 MongoDB Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

module Mongo
  class Error

    # Credential check for MONGODB-AWS authentication mechanism failed.
    #
    # This exception is raised when the driver attempts to verify the
    # credentials via STS prior to sending them to the server, and the
    # verification fails due to an error response from the STS.
    class CredentialCheckError < AuthError
    end
  end
end
